
Redmine - Patch #41678

Fix lost backward compatibility about return type of ProjectQuery#results_scope

2024-11-01 19:01 - Nishida Yuya
Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version:    

Description

r22811 changed return type of ProjectQuery#results_scope : Project::ActiveRecord_Relation => Array of Project instance

That change is no impact for Redmine end users. But it is broken backward compatibility for some Redmine plugins which uses

ProjectQuery#results_scope . This patch fixes it.

In addition, UserQuery#results_scope (same name method) still returns User::ActiveRecord_Relation . And

TimeEntryQuery#results_scope ditto.

Related issue: #23954

Related issues:

Related to Redmine - Feature #23954: Shows the date of the last activity on P... Closed

Associated revisions

Revision 23186 - 2024-11-03 12:53 - Marius BĂLTEANU

Adds test for #41678 (#23954).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

Revision 23187 - 2024-11-03 12:56 - Marius BĂLTEANU

ProjectQuery#results_scope should return Project::ActiveRecord_Relation to keep the backward compatibility (#41678, #23954).

Patch by Nishida Yuya (user:nishidayuya).

History

#1 - 2024-11-01 19:28 - Nishida Yuya

After apply fix_lost_backward_compatibility_about_return_type_of_ProjectQuery_results_scope.patch , Project.load_last_activity_date 's effect still

lives as following:

Apply following patch for check.

diff --git a/app/controllers/projects_controller.rb b/app/controllers/projects_controller.rb

index f9a390c58..11078d89a 100644

--- a/app/controllers/projects_controller.rb

+++ b/app/controllers/projects_controller.rb

@@ -335,7 +335,9 @@ def bulk_destroy

   # Returns the ProjectEntry scope for index

   def project_scope(options={})

-    @query.results_scope(options)

+    @query.results_scope(options).tap do |result|

+      binding.b

+    end

   end

   def retrieve_project_query

 Open /projects with "Last activity" column.

Then, @last_activity_date instance variable is exists following:

[334, 343] in ~/src/github.com/agileware-jp/redmine-dev-mirror/app/controllers/projects_controller.rb
   334|   private

   335|

   336|   # Returns the ProjectEntry scope for index

   337|   def project_scope(options={})

   338|     @query.results_scope(options).tap do |result|

=> 339|       binding.b

   340|     end

   341|   end

   342|

   343|   def retrieve_project_query

=>

#0    block {|result=[#<Project:0x00007fe246c212c8 id: 1, name...|} in project_scope at ~/src/github.com/agile

ware-jp/redmine-dev-mirror/app/controllers/projects_controller.rb:339

  #1    Kernel#tap at <internal:kernel>:90

  # and 70 frames (use `bt' command for all frames)

(ruby) result.to_a.first.instance_variable_get(:@last_activity_date)

Fri, 01 Nov 2024 17:10:02.900305000 UTC +00:00

(ruby) result.to_a.first.instance_variable_get(:@last_activity_date).class

ActiveSupport::TimeWithZone

#2 - 2024-11-03 07:10 - Nishida Yuya

Nishida Yuya wrote:

r22811 changed return type of ProjectQuery#results_scope : Project::ActiveRecord_Relation => Array of Project instance

 First time, I saw this return type change at r23172 (too late sorry...) and found r22811. Currently trunk (r23178) has same issue.

#3 - 2024-11-03 08:40 - Mizuki ISHIKAWA

- File add-test.patch added

I confirmed that the method works without issues after applying the patch.

For the plugin, there might be problems if the class of the returned instance changes, so I would like this patch to be incorporated.

I wrote a simple test and attached it.

#4 - 2024-11-03 12:52 - Marius BĂLTEANU

- Related to Feature #23954: Shows the date of the last activity on Projects administration added

#5 - 2024-11-03 12:57 - Marius BĂLTEANU

- Status changed from New to Closed

- Assignee set to Marius BĂLTEANU

Committed the patches as part of #23954, thank you for finding and fixing this issue.

#6 - 2024-11-05 02:58 - Nishida Yuya

Mizuki ISHIKAWA Awesome!

Marius BĂLTEANU Thank you for your response!

Files

fix_lost_backward_compatibility_about_return_type_of_ProjectQuery_results_scope.patch640 Bytes 2024-11-01 Nishida Yuya

add-test.patch 1.18 KB 2024-11-03 Mizuki ISHIKAWA
